blob: 9045823c7be7e330c983171f210163f30fce6241 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
Nicholas Pigginf49821e2018-02-11 00:25:04 +10007# $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.a files
Nicholas Piggin3a166fc2017-06-20 01:52:05 +10008# from top-level directories in the kernel tree, others are specified in
9# arch/$(ARCH)/Makefile. Ordering when linking is important, and
10# $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
11# which are linked conditionally (not within --whole-archive), and do not
12# require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020013#
14# vmlinux
15# ^
16# |
17# +-< $(KBUILD_VMLINUX_INIT)
18# | +--< init/version.o + more
19# |
20# +--< $(KBUILD_VMLINUX_MAIN)
Nicholas Pigginf49821e2018-02-11 00:25:04 +100021# | +--< drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020022# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100023# +--< $(KBUILD_VMLINUX_LIBS)
24# | +--< lib/lib.a + more
25# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020026# +-< ${kallsymso} (see description in KALLSYMS section)
27#
28# vmlinux version (uname -v) cannot be updated during normal
29# descending-into-subdirs phase since we do not yet know if we need to
30# update vmlinux.
31# Therefore this step is delayed until just before final link of vmlinux.
32#
33# System.map is generated to document addresses of all kernel symbols
34
35# Error out on error
36set -e
37
38# Nice output in kbuild format
39# Will be supressed by "make -s"
40info()
41{
42 if [ "${quiet}" != "silent_" ]; then
43 printf " %-7s %s\n" ${1} ${2}
44 fi
45}
46
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100047# Thin archive build here makes a final archive with symbol table and indexes
48# from vmlinux objects INIT and MAIN, which can be used as input to linker.
49# KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
50# added.
Stephen Rothwella5967db2016-08-24 22:29:19 +100051#
52# Traditional incremental style of link does not require this step
53#
Nicholas Pigginf49821e2018-02-11 00:25:04 +100054# built-in.a output file
Stephen Rothwella5967db2016-08-24 22:29:19 +100055#
56archive_builtin()
57{
Nicholas Pigginf49821e2018-02-11 00:25:04 +100058 info AR built-in.a
59 rm -f built-in.a;
60 ${AR} rcsTP${KBUILD_ARFLAGS} built-in.a \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100061 ${KBUILD_VMLINUX_INIT} \
62 ${KBUILD_VMLINUX_MAIN}
Stephen Rothwella5967db2016-08-24 22:29:19 +100063}
64
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020065# Link of vmlinux.o used for section mismatch analysis
66# ${1} output file
67modpost_link()
68{
Stephen Rothwella5967db2016-08-24 22:29:19 +100069 local objects
70
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100071 objects="--whole-archive \
Nicholas Pigginf49821e2018-02-11 00:25:04 +100072 built-in.a \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100073 --no-whole-archive \
74 --start-group \
75 ${KBUILD_VMLINUX_LIBS} \
76 --end-group"
77
Stephen Rothwella5967db2016-08-24 22:29:19 +100078 ${LD} ${LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020079}
80
81# Link of vmlinux
82# ${1} - optional extra .o files
83# ${2} - output file
84vmlinux_link()
85{
86 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100087 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020088
89 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100090 objects="--whole-archive \
Nicholas Pigginf49821e2018-02-11 00:25:04 +100091 built-in.a \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100092 --no-whole-archive \
93 --start-group \
94 ${KBUILD_VMLINUX_LIBS} \
95 --end-group \
96 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100097
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100098 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100099 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200100 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000101 objects="-Wl,--whole-archive \
Nicholas Pigginf49821e2018-02-11 00:25:04 +1000102 built-in.a \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000103 -Wl,--no-whole-archive \
104 -Wl,--start-group \
105 ${KBUILD_VMLINUX_LIBS} \
106 -Wl,--end-group \
107 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000108
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000109 ${CC} ${CFLAGS_vmlinux} -o ${2} \
110 -Wl,-T,${lds} \
111 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000112 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200113 rm -f linux
114 fi
115}
116
117
118# Create ${2} .o file with all symbols from the ${1} object file
119kallsyms()
120{
121 info KSYM ${2}
122 local kallsymopt;
123
Rusty Russellb92021b2013-03-15 15:04:17 +1030124 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
125 kallsymopt="${kallsymopt} --symbol-prefix=_"
James Hogan6895f972012-09-06 22:11:25 +0100126 fi
127
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200128 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100129 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200130 fi
131
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700132 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030133 kallsymopt="${kallsymopt} --absolute-percpu"
134 fi
135
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700136 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
137 kallsymopt="${kallsymopt} --base-relative"
138 fi
139
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200140 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
141 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200142
Ard Biesheuvela0439342016-02-05 11:25:05 +0100143 local afile="`basename ${2} .o`.S"
144
145 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
146 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200147}
148
149# Create map file with all symbols from ${1}
150# See mksymap for additional details
151mksysmap()
152{
153 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
154}
155
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700156sortextable()
157{
158 ${objtree}/scripts/sortextable ${1}
159}
160
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200161# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200162cleanup()
163{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200164 rm -f .tmp_System.map
165 rm -f .tmp_kallsyms*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200166 rm -f .tmp_vmlinux*
Nicholas Pigginf49821e2018-02-11 00:25:04 +1000167 rm -f built-in.a
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200168 rm -f System.map
169 rm -f vmlinux
170 rm -f vmlinux.o
171}
172
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000173on_exit()
174{
175 if [ $? -ne 0 ]; then
176 cleanup
177 fi
178}
179trap on_exit EXIT
180
181on_signals()
182{
183 exit 1
184}
185trap on_signals HUP INT QUIT TERM
186
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200187#
188#
189# Use "make V=1" to debug this script
190case "${KBUILD_VERBOSE}" in
191*1*)
192 set -x
193 ;;
194esac
195
196if [ "$1" = "clean" ]; then
197 cleanup
198 exit 0
199fi
200
201# We need access to CONFIG_ symbols
Michal Marek423a8152013-02-25 13:47:53 +0100202case "${KCONFIG_CONFIG}" in
203*/*)
204 . "${KCONFIG_CONFIG}"
205 ;;
206*)
207 # Force using a file from the current directory
208 . "./${KCONFIG_CONFIG}"
209esac
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200210
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200211# Update version
212info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900213if [ -r .version ]; then
214 VERSION=$(expr 0$(cat .version) + 1)
215 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200216else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900217 rm -f .version
218 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200219fi;
220
221# final build of init/
Cao jina7b151f2018-02-21 12:25:07 +0800222${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200223
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100224archive_builtin
225
226#link vmlinux.o
227info LD vmlinux.o
228modpost_link vmlinux.o
229
230# modpost vmlinux.o to check for section mismatches
231${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
232
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200233kallsymso=""
234kallsyms_vmlinux=""
235if [ -n "${CONFIG_KALLSYMS}" ]; then
236
237 # kallsyms support
238 # Generate section listing all symbols and add it into vmlinux
239 # It's a three step process:
240 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
241 # but __kallsyms is empty.
242 # Running kallsyms on that gives us .tmp_kallsyms1.o with
243 # the right size
244 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
245 # the right size, but due to the added section, some
246 # addresses have shifted.
247 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100248 # 3) That link may have expanded the kernel image enough that
249 # more linker branch stubs / trampolines had to be added, which
250 # introduces new names, which further expands kallsyms. Do another
251 # pass if that is the case. In theory it's possible this results
252 # in even more stubs, but unlikely.
253 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
254 # other bugs.
255 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200256 #
257 # a) Verify that the System.map from vmlinux matches the map from
258 # ${kallsymso}.
259
260 kallsymso=.tmp_kallsyms2.o
261 kallsyms_vmlinux=.tmp_vmlinux2
262
263 # step 1
264 vmlinux_link "" .tmp_vmlinux1
265 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
266
267 # step 2
268 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
269 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
270
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100271 # step 3
Michael Forneya670b0b2018-03-18 17:54:02 -0700272 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
273 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100274
275 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200276 kallsymso=.tmp_kallsyms3.o
277 kallsyms_vmlinux=.tmp_vmlinux3
278
279 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
280
281 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
282 fi
283fi
284
285info LD vmlinux
286vmlinux_link "${kallsymso}" vmlinux
287
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700288if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
289 info SORTEX vmlinux
290 sortextable vmlinux
291fi
292
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200293info SYSMAP System.map
294mksysmap vmlinux System.map
295
296# step a (see comment above)
297if [ -n "${CONFIG_KALLSYMS}" ]; then
298 mksysmap ${kallsyms_vmlinux} .tmp_System.map
299
300 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200301 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200302 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200303 exit 1
304 fi
305fi